/**************************************************************
 copyright: (C)2007 by parafin
 email: operator@parafin.pp.ru

 This program is free software; you can redistribute  it and/or
 modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of
 the License, or (at your option) any later version.

 This program  is  distributed in  the  hope  that it  will  be
 useful, but  WITHOUT ANY  WARRANTY; without  even the  implied
 warranty  of  MERCHANTABILITY  or  FITNESS  FOR  A  PARTICULAR
 PURPOSE. See the GNU General Public License for more details.

 You should  have received  a copy  of the  GNU General  Public
 License along with  this program;  if not,  write to the  Free
 Software Foundation, Inc., 675 Mass Ave, Cambridge,  MA 02139,
 USA.
 **************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <arpa/inet.h>
#include <signal.h>
#include <ipt_ACCOUNT_cl.h>

const char* dir_in    = "in";
const char* dir_out   = "out";

char* table;

struct ipt_ACCOUNT_context ctx;

void real_work(const char* cur_table, const char* cur_type) {
	struct ipt_acc_handle_ip* entry;
	unsigned int ip, curtime;
	if(ipt_ACCOUNT_read_entries(&ctx, cur_table, 0)) {
		fprintf(stderr, "ipt_ACCOUNT_read_entries(%s) failed: %s\n", cur_table, ctx.error_str);
		ipt_ACCOUNT_deinit(&ctx);
		exit(-1);
	}
	curtime = time(0);
	while(entry = ipt_ACCOUNT_get_next_entry(&ctx)) {
		ip = htonl(entry->ip);
		printf("INSERT INTO %s (ip, bytes, packets, type, time, direction)"
			" VALUES (%u, %u, %u, '%s', FROM_UNIXTIME(%u), '%s')\n",
			table, ip, entry->src_bytes, entry->src_packets, cur_type, curtime, dir_out);
		printf("INSERT INTO %s (ip, bytes, packets, type, time, direction)"
			" VALUES (%u, %u, %u, '%s', FROM_UNIXTIME(%u), '%s')\n",
			table, ip, entry->dst_bytes, entry->dst_packets, cur_type, curtime, dir_in);
	}
}

int main(int argc, char** argv) {
	if(argc != 2) {
		fprintf(stderr, "Usage: %s table\n", argv[0]);
		exit(-1);
	}
	table = argv[1];
	signal(SIGINT, SIG_IGN);
	signal(SIGTERM, SIG_IGN);
	signal(SIGHUP, SIG_IGN);
	/* ipt_ACCOUNT initialization */
	if(ipt_ACCOUNT_init(&ctx))
	{
		fprintf(stderr, "ipt_ACCOUNT_init failed: %s\n", ctx.error_str);
		exit(-1);
	}
#include "config.inc"
	/* ipt_ACCOUNT deinitialization */
	ipt_ACCOUNT_deinit(&ctx);
}
